#include "progress.h"
#include "globals.h"
#include "screen.h"
#include "SDL.h"

XProgress::XProgress()
{
    Initialize();
}

XProgress::XProgress(short i_Max)
{
   Initialize();
   m_Max = i_Max;
}

XProgress::~XProgress()
{
}

void XProgress::Initialize()
{
  m_Current = 0;
  m_Min = 0;
  m_Max = 100;
  m_Width = 200;
  m_Height = 10;
}

void XProgress::SetMax(short i_Max)
{
     m_Max = i_Max;
}     

void XProgress::Step(short i_Step)
{
     m_Current += i_Step;
     
     SDL_Surface* pDisplay = screen;
     
     SDL_Rect rect;
     rect.x = ( pDisplay->w - m_Width ) / 2;
     rect.y = ( pDisplay->h - m_Height ) / 2;
     rect.w = m_Width;
     rect.h = m_Height;
     
     SDL_FillRect( pDisplay, &rect, SDL_MapRGB( pDisplay->format, 13, 191, 223 ) );
     
     const short kBorder = 2;
     
     rect.x = ( ( pDisplay->w - m_Width ) / 2 ) + kBorder;
     rect.y = ( ( pDisplay->h - m_Height ) / 2 ) + kBorder;
     float p = m_Current * 100 / m_Max;
     rect.w = (Uint16)(( m_Width - kBorder * 2 ) * p / 100);
     rect.h = m_Height - ( kBorder * 2 );
     
     // blue
     SDL_FillRect( pDisplay, &rect, SDL_MapRGB( pDisplay->format, 104, 98, 157 ) );
     
     updatescreen();
}
